## NEXT


# v1.0.8

## New features:

- Supports custom chat room attributes.
- Adds the `areaCode` attribute to the `ChatOptions` class to restrict the scope of accessible edge nodes.
- Adds the `isDisabled` attribute to `ChatGroup` to indicate whether a group is disabled. This attribute needs to be set by developers at the server side. This attribute is returned when you call the `fetchGroupInfoFromServer` method in `ChatGroupManager` to get group details.


## Improvements

Removed some redundant logs of the SDK.


## Bugs fixed

- Failures in getting a large number of messages from the server in few scenarios.
- The issue of incorrect data statistics.
- Crashes caused by log printing in rare scenarios.


# v1.0.7

v1.0.7 was released on September 7, 2022.

### New features

- Adds the `customEventHandler` attribute in `ChatClient` to allow you to set custom listeners to receive the data sent from the Android or iOS device to the Flutter.
- Adds event listener classes for event listening.
- Adds the `PushTemplate` method in `PushManager to support custom push templates.
- Adds the `isDisabled` attribute in `Group` to to indicate whether a group is disabled. This attribute needs to be set by developers at the server side. This attribute is returned when you call the `fetchGroupInfoFromServer` method to get group details.
- Adds the the `displayName` attribute in `PushConfigs` to allow you to check the nickname displayed in your push notifications.

### Improvements

- Marked `AddXXXManagerListener` methods (like `addChatManagerListener` and `addContactManagerListener`) as deprecated.

- Modified API references.

# 1.0.6+1

v1.0.6+1 was released on July 22.

### Issues fixed

- The callbacks for messaging thread were not triggered on iOS.
- The callbacks for reaction were not triggered in iOS.
- Occassional crashes occured on Android when retrieving conversations from the server.

## 1.0.5

v1.0.5 was released on June 17.

### New features

- Sending and receiving messages in one-to-one chats, chat groups, and chatrooms;
- Retrieving and managing conversations and messages;
- Managing chat groups and chatrooms;
- Managing contact and block lists;
